<cfcomponent>
	
	<cffunction name="tagSearch" access="remote" returntype="query" hint="I return results of a Flickr search">
		<cfargument name="api_key" type="string" required="true" hint="Application ID">
		<cfargument name="tags" type="string" required="true">
		<cfargument name="per_page" type="numeric" required="false" default="20">

		<cfset var qReturn = queryNew("id,owner,secret,server,farm,title,ispublic,isfriend,isfamily,urithumb,urimedium,urioriginal","integer,varchar,varchar,integer,integer,varchar,integer,integer,integer,varchar,varchar,varchar")>
		<cfset var sURI = "http://api.flickr.com/services/rest/?method=flickr.photos.search&api_key=#arguments.api_key#&tags=#arguments.tags#&per_page=#arguments.per_page#">
		<cfset var stResult = structNew()>
		<cfset var xResult = "">
		<cfset var stData = structNew()>
		<cfset var sKey = "">
		
		<!--- 
		<cfif fileExists("#expandpath('/temp.xml')#")>
			<cffile action="read" file="#expandpath('/temp.xml')#" variable="stResult.filecontent">

		<cfelse>
		 --->
			<cfhttp url="#sURI#" result="stResult" method="get" />
		<!--- 		
		</cfif>
		--->
		
		<cfif len(stResult.fileContent) and isXml(stResult.fileContent)>
			<cfset xResult = xmlParse(stResult.fileContent)>
		</cfif>
		
		<!--- 
			<cffile action="write" file="#expandPath("/temp.xml")#" output="#stResult.fileContent#"> 
		--->

		<cfloop from="1" to="#arrayLen(xResult.rsp.photos.xmlChildren)#" index="i">
				<cfset stData = xResult.rsp.photos.xmlChildren[i].xmlAttributes>
				<cfset stData.urithumb = "http://farm#stData.farm#.static.flickr.com/#stData.server#/#stData.id#_#stData.secret#_t.jpg">
				<cfset stData.urimedium = "http://farm#stData.farm#.static.flickr.com/#stData.server#/#stData.id#_#stData.secret#_m.jpg">
				<cfset stData.urioriginal = "http://farm#stData.farm#.static.flickr.com/#stData.server#/#stData.id#_#stData.secret#.jpg">

				<cfset queryAddRow(qReturn)>

				<cfloop item="sKey" collection="#stData#">
					<cfset querySetCell(qReturn, sKey, stData[sKey])>
				</cfloop>

			</cfloop>
		<cfreturn qReturn>
	</cffunction>

	<cffunction name="getInfo" access="public" returntype="query" hint="I return results of a Flickr search">
		<cfargument name="api_key" type="string" required="true" hint="Application ID">
		<cfargument name="photo_id" type="string" required="true" hint="Photo ID">
		<cfargument name="secret" type="string" required="true" hint="Application ID">

		<cfset var qReturn = queryNew("dateuploaded,description,farm,id,isfavorite,license,rotation,secret,server,title,uri","date,varchar,integer,varchar,integer,integer,integer,varchar,integer,varchar,varchar")>
		<cfset var sURI = "http://api.flickr.com/services/rest/?method=flickr.photos.getInfo&api_key=#arguments.api_key#&photo_id=#arguments.photo_id#&secret=#arguments.secret#">
		<cfset var stResult = structNew()>
		<cfset var stPhoto = structNew()>
		<cfset var xResult = "">
		<cfset var sKey = "">

		<cfhttp url="#sURI#" result="stResult" method="get" />

		<cfif len(stResult.fileContent) and isXml(stResult.fileContent)>
			<cfset xResult = xmlParse(stResult.fileContent)>
			
			<cfset stPhoto = xResult.rsp.photo.xmlAttributes>
			<cfset stPhoto["title"] = xResult.rsp.photo.title.xmlText>
			<cfset stPhoto["description"] = xResult.rsp.photo.description.xmlText>
			<cfset stData.dateuploaded = dateAdd("s", stPhoto.dateuploaded, "January 1 1970 00:00:00")>
			<cfset stData.uri = "http://farm#stPhoto.farm#.static.flickr.com/#stPhoto.server#/#stData.id#_#stPhoto.secret#_m.jpg">

			<cfset queryAddRow(qReturn)>

			<cfloop item="sKey" collection="#stPhoto#">
				<cfset querySetCell(qReturn, sKey, stPhoto[sKey])>
			</cfloop>

		</cfif>
		
		<cfreturn qReturn>
	</cffunction>

</cfcomponent>




